//+------------------------------------------------------------------+
//|                                                     MTF_DEMA.mq4 |
//|                                    Copyright  2016, imamushroom |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2016, imamushroom"
#property link      "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue

//**************************************************************************/
extern int TimeFrame=0;
extern int MAPeriod=2;
extern int ma_shift=0;
extern ENUM_APPLIED_PRICE applied_price=PRICE_CLOSE;
extern color MA_Line_Color=Aqua;
extern int MA_Line_Width=2;
extern ENUM_LINE_STYLE MA_Line_Style=STYLE_SOLID;

double ExtMapBuffer1[];
double EMAbuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name,price_name;
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE,MA_Line_Style,MA_Line_Width,MA_Line_Color);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   SetIndexBuffer(1,EMAbuffer);       
   SetIndexStyle(1, DRAW_NONE);
//---- name for DataWindow and indicator subwindow label   

   short_name="M_DEMA(";
     
   switch(applied_price)
     {
      case 0 : price_name = "C"; break;
      case 1 : price_name = "O"; break;
      case 2 : price_name = "H"; break;
      case 3 : price_name = "L"; break;
      case 4 : price_name = "M"; break;
      case 5 : price_name = "T"; break;
      case 6 : price_name = "W"; break;
     }
      
   switch(TimeFrame)
     {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="Current";
     }
   IndicatorShortName(short_name+MAPeriod+price_name+") "+TimeFrameStr);
   
   ArrayResize(EMAbuffer,MAPeriod);
   ArrayInitialize(EMAbuffer,0.0);
  return(0);
  }
//----

//+------------------------------------------------------------------+
//| MTF DEMA                                                         |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();

// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame);

   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
     {
      if(Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/

      for (int z=MAPeriod-1; z>=0; z--) 
         EMAbuffer[z] = iMA(NULL,TimeFrame,MAPeriod,0,MODE_EMA,applied_price,y+z); 
         
//---- main indicator     
      ExtMapBuffer1[i] = 2 * iMA(NULL,TimeFrame,MAPeriod,0,MODE_EMA,applied_price,y) - iMAOnArray(EMAbuffer,0,MAPeriod,0,MODE_EMA,0);
     }
   return(0);
  }
//+------------------------------------------------------------------+
